## Classes

<dl>
<dt><a href="#AdPlaylistAPI">AdPlaylistAPI</a></dt>
<dd></dd>
</dl>

## Typedefs

<dl>
<dt><a href="#AdPlaylistSetup">AdPlaylistSetup</a> : <code>Object</code></dt>
<dd><p>Ad configuration for the upcoming content video.</p>
</dd>
</dl>

<a name="AdPlaylistAPI"></a>

## AdPlaylistAPI
**Kind**: global class  

* [AdPlaylistAPI](#AdPlaylistAPI)
    * [new AdPlaylistAPI(playerProxy, adsAPI)](#new_AdPlaylistAPI_new)
    * [.error](#AdPlaylistAPI+error) ⇒ <code>PluginError</code>
    * [.rawVMAP](#AdPlaylistAPI+rawVMAP) ⇒ <code>XML</code>
    * [.initAdPlaylist(playlistSpecs, vastMacros)](#AdPlaylistAPI+initAdPlaylist) ⇒ <code>Promise</code>
    * [.startAdPlaylist()](#AdPlaylistAPI+startAdPlaylist) ⇒ <code>Promise</code>
    * [.stopAdPlaylist()](#AdPlaylistAPI+stopAdPlaylist) ⇒ <code>Promise</code>

<a name="new_AdPlaylistAPI_new"></a>

### new AdPlaylistAPI(playerProxy, adsAPI)

| Param | Type | Description |
| --- | --- | --- |
| playerProxy | <code>Object</code> | extended from [FacadeBase](FacadeBase) |
| adsAPI | <code>Object</code> | is a reference to the session AdSlotAPI |

<a name="AdPlaylistAPI+error"></a>

### adPlaylistAPI.error ⇒ <code>PluginError</code>
Requests details about the most recent error that has occurred.

**Kind**: instance property of <code>[AdPlaylistAPI](#AdPlaylistAPI)</code>  
**Returns**: <code>PluginError</code> - Description object of the most recent error or `null`.  
<a name="AdPlaylistAPI+rawVMAP"></a>

### adPlaylistAPI.rawVMAP ⇒ <code>XML</code>
Returns the VMAP that has been collected for the current (content) session

**Kind**: instance property of <code>[AdPlaylistAPI](#AdPlaylistAPI)</code>  
**Returns**: <code>XML</code> - XML as live parsable DOM representation, querySelector and similar work on this  
<a name="AdPlaylistAPI+initAdPlaylist"></a>

### adPlaylistAPI.initAdPlaylist(playlistSpecs, vastMacros) ⇒ <code>Promise</code>
Starts requesting a VMAP from the ad server

**Kind**: instance method of <code>[AdPlaylistAPI](#AdPlaylistAPI)</code>  
**Returns**: <code>Promise</code> - Resolves if loading the VMAP has been completed  

| Param | Type | Description |
| --- | --- | --- |
| playlistSpecs | <code>[AdPlaylistSetup](#AdPlaylistSetup)</code> | Ad configuration for the upcoming content video. |
| vastMacros | <code>Object</code> | VAST macros and their values as defined in  https://interactiveadvertisingbureau.github.io/vast/vast4macros/vast4-macros-latest.html |

<a name="AdPlaylistAPI+startAdPlaylist"></a>

### adPlaylistAPI.startAdPlaylist() ⇒ <code>Promise</code>
Starts playback and monitoring of the content and automatically inserts ad-slots
based on the `timeOffset` values of each VMAP AdBreak.
AdBreaks with a `timeOffset` equally to `0`, `"start"` or `"0%"` get requested immediately.

**Kind**: instance method of <code>[AdPlaylistAPI](#AdPlaylistAPI)</code>  
**Returns**: <code>Promise</code> - Resolves if the playback started  
<a name="AdPlaylistAPI+stopAdPlaylist"></a>

### adPlaylistAPI.stopAdPlaylist() ⇒ <code>Promise</code>
Immediately stops monitoring content playback.
AdBreaks that have already started remain until they complete. If necessary, they must be canceled
via the `AdSlotAPI.stopAdSlot()`.

**Kind**: instance method of <code>[AdPlaylistAPI](#AdPlaylistAPI)</code>  
**Returns**: <code>Promise</code> - - Whether the ad slot could be closed and cleaned up or not.  
<a name="AdPlaylistSetup"></a>

## AdPlaylistSetup : <code>Object</code>
Ad configuration for the upcoming content video.

**Kind**: global typedef  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| tag | <code>string</code> | VMAP Request URL |
| response | <code>string</code> | direct VMAP XML |
| preroll | <code>Object</code> | Separation Clip and Prefetching setup for the adBreak |
| midroll | <code>Object</code> | Separation Clip and Prefetching setup |
| postroll | <code>Object</code> | Separation Clip and Prefetching setup |
| overlay | <code>Object</code> | Prefetching setup |

